//+------------------------------------------------------------------+
//| Die Strke des Corrected Average (CA) besteht darin,             |
//| dass der aktuelle Wert der Zeitreihe einen von der momentanen    |
//| Volatilitt abhngigen Schwellenwert berschreiten muss,         |
//| damit der Filter steigt bzw. fllt, wodurch Fehlsignale          |
//| in trendschwachen Phasen vermieden werden.                       |
//| -A.Uhl-                                                          |
//+------------------------------------------------------------------+
//|Germany, 23.03.2007


#property copyright "A.Uhl,  RickD 2006, Alexander Piechotta"
#property link      "http://onix-trade.net/forum/"

#define major   1
#define minor   0


#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1  Gold

extern int HalfLength = 35;
extern int Price = PRICE_CLOSE;


double MABuf[];
double CABuf[];


void init()
{       
IndicatorBuffers(2);
SetIndexStyle(0, DRAW_LINE, STYLE_SOLID,1);
SetIndexDrawBegin(0, HalfLength);

SetIndexBuffer(0, CABuf);
SetIndexBuffer(1, MABuf);

IndicatorShortName("Corrected Average (CA) ("+HalfLength+")");
}


void deinit(){
}  


void start() 
{
   int counted_bars=IndicatorCounted();
   int i,j,k,limit;
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars+HalfLength,Bars-1);
  
  for (i=limit-1; i >= 0; i--)
  {
      double sum  = (HalfLength+1)*iMA(NULL,0,1,0,MODE_SMA,Price,i);
      double sumw = (HalfLength+1);
      for(j=1, k=HalfLength; j<=HalfLength; j++, k--)
      {
         sum  += k*iMA(NULL,0,1,0,MODE_SMA,Price,i+j);
         sumw += k;
         if (j<=i)
         {
            sum  += k*iMA(NULL,0,1,0,MODE_SMA,Price,i-j);
            sumw += k;
         }
      }
      MABuf[i] = sum/sumw;
    
      if (i == Bars-1) {  CABuf[i] = MABuf[i];  continue; }
    
      double v1 = MathPow(iStdDev(NULL, 0, HalfLength, 0, MODE_SMA, Price, i), 2);
      double v2 = MathPow(CABuf[i+1] - MABuf[i], 2);
    
      double v = 0; if (v2 < v1 || v2 == 0) v = 0; else v = 1 - v1/v2;

      CABuf[i] = CABuf[i+1] + v*(MABuf[i]-CABuf[i+1]);
//      CABuf[i] = MABuf[i];
  }
}